package csci1902.hw3;

import java.awt.Point;
import java.util.ArrayList;
import java.util.List;

public class ForagerAnt extends Ant {
	public Point position;
	int maximumFood;
	int foodCarry;
	int foodCarryNext;
	World world;
	public ForagerAnt(int maxFood, World worldo, Point pos){
		super(worldo, pos);
		position = pos;
		maximumFood=maxFood;
		world=worldo;
		foodCarry=0;
		foodCarryNext=0;
	}
	public int getFoodUnits(){
		return foodCarry;
	}
	public void act(List<Entity> neighbors){
		Point currentPosition=getPosition();
		List<Point> neighborPoints = new ArrayList<Point>();
		neighborPoints=world.getNeighboringCells(currentPosition);
		double best=6.0;
		Point bestPoint=new Point();
		if (foodCarry==0){
			for(int i=0;i<neighbors.size();i++){
				if(neighbors.get(i).isFoodSource()==true){
					foodCarryNext=neighbors.get(i).collectFood(maximumFood);
					return;
				}
			}
		}
		if (foodCarry!=0){
			for(int i=0;i<neighbors.size();i++){
				if(neighbors.get(i).isFoodSink()==true){
					neighbors.get(i).depositFood(foodCarry);
					foodCarryNext=0;
					return;
				}
			}
			world.depositFoodPheromone(currentPosition.x, currentPosition.y, 5.0);
			goTowardsHome();
			return;
		}
		if (foodCarry==0){
			for(int i=0;i<neighborPoints.size();i++){
				if(world.getFoodPheromone(neighborPoints.get(i).x, neighborPoints.get(i).y)
					<best&&world.getFoodPheromone(neighborPoints.get(i).x, neighborPoints.get(i).y)
						>=.1){
					best=world.getFoodPheromone(neighborPoints.get(i).x, neighborPoints.get(i).y);
					bestPoint=neighborPoints.get(i);
				}
			}
			if(best<6){
				setNextPosition(bestPoint);
				return;
			}
			moveRandomly();
			return;
		}
	}


	public void update(){
		super.update();
		foodCarry=foodCarryNext;
		return;
	}
	
}