package csci1902.hw3;

import java.awt.Point;
import java.util.List;

public class Spider extends Entity {
	int energy;
	int energyNext;
	World currentWorld;
	public Spider(World world, Point pos){
		super(world, pos);
		currentWorld = world;
		energy = 1000;
		energyNext=1000;
	}
	public void act(List<Entity> neighbors){

		for(int i=0;i<neighbors.size();i++){
			if (neighbors.get(i).isEdible()){
				if(neighbors.get(i).eat()){
					energyNext+=10;
					return;
				} else {
					energyNext--;
					if (energyNext == 0){
						die();
					}
					return;
				}
			}
		}
		moveRandomly();
		energyNext--;
		if (energyNext == 0){
			die();
		}
		return;
	}
	public void update(){
		super.update();
		energy=energyNext;
		return;
	}
}
