package csci1902.hw3;

import java.awt.Point;

import junit.framework.TestCase;

public class WasteDumpTest extends TestCase {
    World world;
    WasteDump dump;
    
    protected void setUp() {
        world = new World(10, 10);
        dump = new WasteDump(world, new Point(5,5));
    }
    
    public void testIsWasteSink() {
        assertTrue(dump.isWasteSink());
    }
    
    public void testDepositWaste() {
        try {
            dump.depositWaste(5);
        } catch (UnsupportedOperationException e) {
            fail("depositWaste threw");
        }
    }

}
